'**************************************************************************
'*             HTBasic Plus for Windows Setup Script (20-Feb-96)
'**************************************************************************

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

''Dialog ID's
CONST WELCOME                  = 100
CONST ASKQUIT                  = 200
CONST DESTPATH                 = 300
CONST EXITFAILURE              = 400
CONST EXITQUIT                 = 600
CONST EXITSUCCESS              = 700
CONST OPTIONS                  = 800
CONST BADPATH                  = 6400

CONST HELPWELCOME              = 1000
CONST VERPATH                  = 1100
CONST EXITFAILNOTWIN31         = 1200
CONST EXITFAILNOTENH           = 1300
CONST EXITFAILNOTPAGING        = 1325
CONST EXITFAILNOTINTEL         = 1350
CONST EXITFAILRUNAPP           = 1360

''Bitmap ID
CONST LOGO = 1

CONST EXITSUCCESSW32S   = 701
CONST INSTHELP          = 800
CONST WELCOMEHELP       = 900
CONST CUSTINST          = 6200
CONST TOOBIG            = 6300
CONST NOWIN32S          = 6500

''File Types
CONST PLUSFILES    = 1
CONST PLUSEXFILES  = 2

CONST SW_SHOW      = 5

GLOBAL DEST$        ''Default destination directory.
GLOBAL DESTSYS$      ''Windows\System directory.
GLOBAL WINDRIVE$    ''Windows drive letter.
GLOBAL NTSYS$        ''Windows\System32 directory
GLOBAL WINNT%

''CustInst list symbol names
GLOBAL PlusNEEDS$   ''Option list costs per drive
GLOBAL PlusExNEEDS$
GLOBAL EXTRACOSTS$  ''List of extra costs to add per drive
GLOBAL BIGLIST$     ''List of option files cost calc results (boolean)

''Dialog list symbol names
GLOBAL CHECKSTATES$
GLOBAL STATUSTEXT$
GLOBAL DRIVETEXT$

GLOBAL FIRSTTIME%
GLOBAL WIN31INSTALLED%

DECLARE SUB WinExec LIB "kernel" (szCmdLine$, nCmdShow%)
DECLARE SUB AddOptFilesToCopyList (ftype%)
DECLARE SUB RecalcOptFiles (ftype%)
DECLARE SUB RecalcPath
DECLARE SUB SetDriveStatus
DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING
DECLARE FUNCTION OnWindowsNT LIB "INIUPD.DLL" AS INTEGER
DECLARE FUNCTION IsRunningApp LIB "INIUPD.DLL" AS INTEGER



INIT:

    AP_CUIDLL$ = "htcuistf.dll"         ''custom user interface dll
    HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure

    SetBitmap AP_CUIDLL$, LOGO
    SetTitle "TransEra HTBasic Plus 5.2 Setup"

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
        szInf$ = GetSymbolValue("STF_CWDDIR") + "HTBPLUS.INF"
    END IF
    ReadInfFile szInf$

    WINDRIVE$ = MID$(GetWindowsDir, 1, 1)
    DEST$ = WINDRIVE$ + ":\HTBWin"
    DESTSYS$ = GetWindowsSysDir()
    NTSYS$ = GetWindowsDir() + "System32\"

    ''CustInst list symbols
    CHECKSTATES$ = "CheckItemsState"
    STATUSTEXT$  = "StatusItemsText"
    DRIVETEXT$   = "DriveStatusText"
    FOR i% = 1 TO 2 STEP 1
        AddListItem CHECKSTATES$, "ON"
    NEXT i%
    FOR i% = 1 TO 2 STEP 1
        AddListItem STATUSTEXT$, ""
    NEXT i%
    FOR i% = 1 TO 7 STEP 1
        AddListItem DRIVETEXT$, ""
    NEXT i%
    ReplaceListItem DRIVETEXT$, 7, DEST$

    ''Disk cost list symbols
    PlusNEEDS$  = "PlusNeeds"
    PlusExNEEDS$= "PlusExNeeds"
    EXTRACOSTS$ = "ExtraCosts"
    BIGLIST$    = "BigList"
    FOR i% = 1 TO 2 STEP 1
        AddListItem BIGLIST$, ""
    NEXT i%
    FOR i% = 1 TO 26 STEP 1
        AddListItem EXTRACOSTS$, "0"
    NEXT i%

    FIRSTTIME% = 1
    RecalcPath
    SetDriveStatus

AP_WELCOME:
    sz$ = UIStartDlg(AP_CUIDLL$, WELCOME, "FInfoDlgProc", WELCOMEHELP, HELPPROC$)
    IF sz$ = "CONTINUE" THEN
        UIPop 1
    ELSE
        UIPop 1
        GOSUB AP_ASKQUIT
        GOTO AP_WELCOME
    END IF

CHECK:
    WIN31INSTALLED% = 0    '' BOB
    '' Can not run on versions less than 3.10.
    IF GetWindowsMajorVersion < 3 THEN
        ExitCode% = EXITFAILNOTWIN31
        GOTO QUIT
    END IF
    IF GetWindowsMajorVersion = 3 AND GetWindowsMinorVersion < 10 THEN
        ExitCode% = EXITFAILNOTWIN31
        GOTO QUIT
    END IF
    '' Check that we are not runnig on Chicago, including pre-released
    '' Chicago versions.
    IF GetWindowsMajorVersion * 100 + GetWindowsMinorVersion > 350 THEN
        ExitCode% = EXITSUCCESS
        GOTO INSTALLED
    END IF
    IF GetWindowsMode < 2  THEN
        IF OnWindowsNT() THEN
            ExitCode% = EXITFAILNOTINTEL '' Running on Windows NT (on RISC)
        ELSE
            ExitCode% = EXITFAILNOTENH   '' Standard Mode Windows
        END IF
        GOTO QUIT
    END IF
    IF OnWindowsNT() THEN
        ExitCode% = EXITSUCCESS
        WINNT% = 1
        GOTO INSTALLED
    END IF
    ExitCode% = EXITSUCCESS

    if IsRunningApp() <> 0 THEN
        ExitCode% = EXITFAILRUNAPP
        GOTO QUIT
    END IF

    WIN31INSTALLED% = 1    '' BOB

INSTALLED:

QUIT:
    '' Install error handler for final message box routines
    ON ERROR GOTO ERRQUIT
    IF ERR = 0 THEN
        dlg% = ExitCode%
    ELSEIF ERR = STFQUIT THEN
        dlg% = EXITQUIT
        ExitCode% = EXITQUIT
    ELSE
        dlg% = EXITFAILURE
        ExitCode% = EXITQUIT
    END IF

QUITL1:
    IF ExitCode% = EXITSUCCESS THEN
        GOTO AP_CUSTINST
    END IF

    UIPop 1
    END


'' Fatal error handler for error message routine
ERRQUIT:
''  i% = DoMsgBox("Setup sources were corrupted!", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
    END

'' Bypass run-time errors. Let final dialog box display fatal error message.
ERRNORMAL:
    '' Check if user cancelled setup
    IF ERR = STFQUIT THEN
    GOTO QUIT
    END IF
    RESUME NEXT


BADPATH:
    sz$ = UIStartDlg(CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        GOTO BADPATH
    END IF
        UIPop 1
    RETURN

ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
        UIPop 1
        UIPopAll
        ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
        GOTO ASKQUIT
    ELSE
        UIPop 1
    END IF
    RETURN



'' Display Main Dialog Box:

AP_CUSTINST:

    sz$ = UIStartDlg(AP_CUIDLL$, CUSTINST, "FCustInstDlgProc", INSTHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
        ''Install only if it will fit.
        FOR i% = 1 TO 2 STEP 1
            IF GetListItem(BIGLIST$, i%) <> "" THEN
                GOSUB AP_TOOBIG
                GOTO AP_CUSTINST
            END IF
        NEXT i%
        UIPop 1
        GOTO AP_INSTALL
    ELSEIF sz$ = "PATH" THEN
        GOTO AP_GETPATH
    ELSEIF sz$ = "CHK1" THEN
        RecalcOptFiles PLUSFILES
        SetDriveStatus
        GOTO AP_CUSTINST
    ELSEIF sz$ = "CHK2" THEN
        RecalcOptFiles PLUSEXFILES
        SetDriveStatus
        GOTO AP_CUSTINST
    ELSEIF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO AP_CUSTINST
    ELSE
        GOSUB AP_ASKQUIT
        GOTO AP_CUSTINST
    END IF
    END

AP_INSTALL:

    ClearCopyList
    SrcDir$ = GetSymbolValue("STF_SRCDIR")

    IF GetListItem(CHECKSTATES$, PLUSFILES) = "ON" THEN
       IF WIN31INSTALLED% = 1 THEN
         AddSectionFilesToCopyList "Win31Files", SrcDir$, DESTSYS$
       END IF
       IF WINNT% = 1 THEN
         AddSectionFilesToCopyList "WinNTFiles", SrcDir$, NTSYS$
       END IF
    END IF
    AddOptFilesToCopyList PLUSFILES
    AddOptFilesToCopyList PLUSEXFILES
    CreateDir DEST$, cmoNone
    CopyFilesInCopyList

    CreateProgmanGroup "TransEra HTBasic", "", cmoNone
    ShowProgmanGroup  "TransEra HTBasic", 1, cmoNone
    IF GetListItem(CHECKSTATES$, PLUSFILES) = "ON" THEN
        CreateProgmanItem "TransEra HTBasic", "HTBasic Plus Help", MakePath(DEST$,"BPLUS.HLP"), "", cmoOverwrite
        CreateProgmanItem "TransEra HTBasic", "BPLUS.TXT", "NOTEPAD "+MakePath(DEST$,"BPLUS.TXT"), "", cmoOverwrite
        CreateProgmanItem "TransEra HTBasic", "Screen Builder", MakePath(DEST$,"SCR_BLDR.EXE"), "", cmoOverwrite
    END IF

AP_QUIT:
    ON ERROR GOTO AP_ERRQUIT

    IF ERR = 0 THEN
        dlg% = EXITSUCCESS
    ELSEIF ERR = STFQUIT THEN
        dlg% = EXITQUIT
    ELSE
        dlg% = EXITFAILURE
    END IF
AP_QUITL1:
    IF dlg% = EXITSUCCESS THEN
        sz$ = UIStartDlg(AP_CUIDLL$, EXITSUCCESS, "FInfo0DlgProc", 0, "")
    ELSE
        sz$ = UIStartDlg(AP_CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    END IF
    IF sz$ = "REACTIVATE" THEN
        GOTO AP_QUITL1
    ELSEIF sz$ = "BACK" THEN
        WinExec "NOTEPAD " + MakePath(DEST$, "BPLUS.TXT"), SW_SHOW
        GOTO AP_QUITL1
    END IF
    UIPop 1

    END


AP_ERRQUIT:
''  i% = DoMsgBox("Setup sources were corrupted!", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
    END



AP_GETPATH:
    SetSymbolValue "EditTextIn", DEST$
    SetSymbolValue "EditFocus", "END"
AP_GETPATHL1:
    sz$ = UIStartDlg(AP_CUIDLL$, DESTPATH, "FEditDlgProc", WELCOMEHELP, HELPPROC$)

    IF sz$ = "CONTINUE" THEN
        olddest$ = DEST$
        DEST$ = GetSymbolValue("EditTextOut")

        ''Validate new path.
        IF IsDirWritable(DEST$) = 0 THEN
            GOSUB AP_BADPATH
            GOTO AP_GETPATHL1
        END IF
        UIPop 1

        ''Truncate display if too long.
        IF LEN(DEST$) > 23 THEN
            ReplaceListItem DRIVETEXT$, 7, MID$(DEST$, 1, 23)+"..."
        ELSE
            ReplaceListItem DRIVETEXT$, 7, DEST$
        END IF

        ''Recalc if path changed.
        IF (olddest$ <> DEST$) AND (olddest$ <> DEST$+"\") AND (olddest$+"\" <> DEST$) THEN
            RecalcPath
            SetDriveStatus
        END IF

        olddest$ = ""
        GOTO AP_CUSTINST
    ELSEIF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO AP_GETPATHL1
    ELSEIF sz$ = "EXIT" THEN
        GOSUB AP_ASKQUIT
        GOTO AP_GETPATHL1
    ELSE
        UIPop 1
        GOTO AP_CUSTINST
    END IF



AP_TOOBIG:
    sz$ = UIStartDlg(AP_CUIDLL$, TOOBIG, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO AP_TOOBIG
    END IF
    UIPop 1
    RETURN



AP_BADPATH:
    sz$ = UIStartDlg(AP_CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        RecalcPath
        SetDriveStatus
        GOTO AP_BADPATH
    END IF
    UIPop 1
    RETURN



AP_ASKQUIT:
    sz$ = UIStartDlg(AP_CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
        UIPopAll
        ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
        GOTO AP_ASKQUIT
    ELSE
        UIPop 1
    END IF
    RETURN



'**
'** Purpose:
'**     Adds the specified option files to the copy list.
'** Arguments:
'**     ftype%  - type of files to add, one of the following:
'**             PLUSFILES, PLUSEXFILES
'** Returns:
'**     none.
'*************************************************************************
SUB AddOptFilesToCopyList (ftype%) STATIC

    IF GetListItem(CHECKSTATES$, ftype%) = "ON" THEN
        SrcDir$ = GetSymbolValue("STF_SRCDIR")
        IF ftype% = PLUSFILES THEN
            AddSectionFilesToCopyList "PlusFiles", SrcDir$, DEST$
        ELSEIF ftype% = PLUSEXFILES THEN
            AddSectionFilesToCopyList "PlusExFiles", SrcDir$, DEST$
        END IF
        SrcDir$ = ""
    END IF
END SUB


'**
'** Purpose:
'**     Recalculates disk space for the given option files and sets
'**     the status info symbol "StatusItemsText".
'** Arguments:
'**     ftype% - type of files to add, one of the following:
'**             PLUSFILES, PLUSEXFILES
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcOptFiles (ftype%) STATIC
    CursorSave% = ShowWaitCursor()
    ClearCopyList
    AddOptFilesToCopyList ftype%

    fExtra% = 0
    IF ftype% = PLUSFILES THEN
        ListSym$ = PlusNEEDS$
    ELSEIF ftype% = PLUSEXFILES THEN
        ListSym$ = PlusExNEEDS$
    END IF

    StillNeed& = GetCopyListCost(EXTRACOSTS$, ListSym$, "")

    cost& = 0
    FOR i% = 1 TO 26 STEP 1
        cost&  = cost& + VAL(GetListItem(ListSym$, i%))
    NEXT i%

    IF ftype% = PLUSFILES AND GetListItem(CHECKSTATES$, PLUSFILES) = "ON" THEN
       IF WIN31INSTALLED% = 1 THEN
          sz$ = MakePath(DESTSYS$,"MSVCRT20.DLL")
          IF DoesFileExist(sz$, femExists) = 0 THEN
            cost& = cost& + 244736      ''size of MSVCRT20.32S
          END IF
       END IF
       IF WINNT% = 1 THEN
          sz$ = MakePath(NTSYS$,"MSVCRT20.DLL")
          IF DoesFileExist(sz$, femExists) = 0 THEN
            cost& = cost& + 253952      ''size of MSVCRT20.NT
          END IF
       END IF
    END IF

    ReplaceListItem STATUSTEXT$, ftype%, STR$(cost& / 1024) + " K"

    IF FIRSTTIME% = 1 THEN
        IF cost& > 0 THEN
            ReplaceListItem CHECKSTATES$, ftype%, "ON"
        ELSE
            ReplaceListItem CHECKSTATES$, ftype%, "OFF"
            ReplaceListItem STATUSTEXT$, ftype%, "Installed"
        END IF
    END IF

    IF StillNeed& > 0 THEN
        ReplaceListItem BIGLIST$, ftype%, "YES"
    ELSE
        ReplaceListItem BIGLIST$, ftype%, ""
    END IF

    RestoreCursor CursorSave%
    ListSym$ = ""
END SUB


'**
'** Purpose:
'**     Recalculates disk space and sets option status info according
'**     to the current destination path.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB RecalcPath STATIC

    CursorSave% = ShowWaitCursor()

    RecalcOptFiles PLUSFILES
    RecalcOptFiles PLUSEXFILES
    FIRSTTIME% = 0

    RestoreCursor CursorSave%
END SUB


'**
'** Purpose:
'**     Sets drive status info according to latest disk space calcs.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB SetDriveStatus STATIC

    drive$ = MID$(DEST$, 1, 1)
    ndrive% = ASC(ucase$(drive$)) - ASC("A") + 1
    cost& = VAL(GetListItem(PlusNEEDS$, ndrive%)) + VAL(GetListItem(PlusExNEEDS$, ndrive%))

'' FIX UP THE COSTS
    IF GetListItem(CHECKSTATES$, PLUSFILES) = "ON" THEN
      IF WIN31INSTALLED% = 1 THEN
        sz$ = MakePath(DESTSYS$,"MSVCRT20.DLL")
        IF DoesFileExist(sz$, femExists) = 0 THEN
          cost& = cost& + 244736          ''size of MSVCRT20.32S
        END IF
      END IF
      IF WINNT% = 1 THEN
        sz$ = MakePath(NTSYS$,"MSVCRT20.DLL")
        IF DoesFileExist(sz$, femExists) = 0 THEN
          cost& = cost& + 253952          ''size of MSVCRT20.NT
        END IF
      END IF
    END IF

    free& = GetFreeSpaceForDrive(drive$)
    ReplaceListItem DRIVETEXT$, 1, drive$ + ":"
    ReplaceListItem DRIVETEXT$, 2, STR$(cost& / 1024) + " K"
    ReplaceListItem DRIVETEXT$, 3, STR$(free& / 1024) + " K"

    ReplaceListItem DRIVETEXT$, 4, ""
    ReplaceListItem DRIVETEXT$, 5, ""
    ReplaceListItem DRIVETEXT$, 6, ""
END SUB


'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
    IF szDir$ = "" THEN
        MakePath = szFile$
    ELSEIF szFile$ = "" THEN
        MakePath = szDir$
    ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
        MakePath = szDir$ + szFile$
    ELSE
        MakePath = szDir$ + "\" + szFile$
    END IF
END FUNCTION
